{
    "$graph": [
        {
            "class": "CommandLineTool",
            "id": "#bedtools-bamtofastq-pe.cwl",
            "baseCommand": [
                "bedtools",
                "bamtofastq"
            ],
            "inputs": [
                {
                    "id": "#bedtools-bamtofastq-pe.cwl/bedtools_bamtofastq_pe/input",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-i"
                    }
                },
                {
                    "id": "#bedtools-bamtofastq-pe.cwl/bedtools_bamtofastq_pe/fq",
                    "type": "string",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-fq"
                    }
                },
                {
                    "id": "#bedtools-bamtofastq-pe.cwl/bedtools_bamtofastq_pe/fq2",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-fq2"
                    }
                }
            ],
            "label": "bedtools-bamtofastq-pe",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/bedtools:2.29.2--hc088bd4_0"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "outputs": [
                {
                    "id": "#bedtools-bamtofastq-pe.cwl/bedtools_bamtofastq_pe/output_fq1",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.fq)"
                    }
                },
                {
                    "id": "#bedtools-bamtofastq-pe.cwl/bedtools_bamtofastq_pe/output_fq2",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.fq2)"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "fastp"
            ],
            "inputs": [
                {
                    "id": "#fastp-pe.cwl/fastq1",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-i"
                    }
                },
                {
                    "id": "#fastp-pe.cwl/fastq2",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-I"
                    }
                },
                {
                    "default": 1,
                    "id": "#fastp-pe.cwl/threads",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--thread"
                    }
                },
                {
                    "id": "#fastp-pe.cwl/input",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 0
                    }
                },
                {
                    "id": "#fastp-pe.cwl/length",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--length_required"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#fastp-pe.cwl/out_fastq1",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.fastq1.basename.replace(/\\.gz$|\\.bz2$/, '').replace(/\\.fq$|\\.fastq$/, '')).fastp.fastq"
                    }
                },
                {
                    "id": "#fastp-pe.cwl/out_fastq2",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.fastq2.basename.replace(/\\.gz$|\\.bz2$/, '').replace(/\\.fq$|\\.fastq$/, '')).fastp.fastq"
                    }
                }
            ],
            "arguments": [
                "-o",
                "$(inputs.fastq1.basename.replace(/\\.gz$|\\.bz2$/, '').replace(/\\.fq$|\\.fastq$/, '')).fastp.fastq",
                "-O",
                "$(inputs.fastq2.basename.replace(/\\.gz$|\\.bz2$/, '').replace(/\\.fq$|\\.fastq$/, '')).fastp.fastq",
                {
                    "position": 0,
                    "prefix": "",
                    "shellQuote": false,
                    "valueFrom": "--trim_poly_x "
                }
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/fastp:0.20.0--hdbcaa40_0"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "id": "#fastp-pe.cwl"
        },
        {
            "class": "CommandLineTool",
            "id": "#fastq_pair.cwl",
            "baseCommand": [
                "fastq_pair"
            ],
            "inputs": [
                {
                    "id": "#fastq_pair.cwl/fastq_pair/fq1",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                },
                {
                    "id": "#fastq_pair.cwl/fastq_pair/fq2",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#fastq_pair.cwl/fastq_pair/fq1_paired",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.fq1.basename).paired.fq"
                    }
                },
                {
                    "id": "#fastq_pair.cwl/fastq_pair/fq2_paired",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.fq2.basename).paired.fq"
                    }
                }
            ],
            "label": "fastq_pair",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/fastq-pair:1.0--he1b5a44_1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.fq1)",
                            "writable": true
                        },
                        {
                            "entry": "$(inputs.fq2)",
                            "writable": true
                        }
                    ]
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#kz_filter.cwl",
            "baseCommand": [
                "kz"
            ],
            "inputs": [
                {
                    "id": "#kz_filter.cwl/kz_filter/threshold",
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "--threshold",
                        "shellQuote": false,
                        "position": 0
                    },
                    "https://www.sevenbridges.com/toolDefaultValue": "0.1"
                },
                {
                    "id": "#kz_filter.cwl/kz_filter/input_fq",
                    "type": "File"
                },
                {
                    "id": "#kz_filter.cwl/kz_filter/output_fq",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#kz_filter.cwl/kz_filter/output",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.output_fq)"
                    }
                }
            ],
            "label": "kz-filter",
            "arguments": [
                {
                    "prefix": "",
                    "shellQuote": false,
                    "position": 0,
                    "valueFrom": "--filter"
                }
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "yyasumizu/ko:0.1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "stdin": "$(inputs.input_fq.path)",
            "stdout": "$(inputs.output_fq)"
        },
        {
            "class": "CommandLineTool",
            "id": "#mk_summary_virus_count.cwl",
            "baseCommand": [
                "python",
                "/workdir/mk_summary_virus_count.py"
            ],
            "inputs": [
                {
                    "id": "#mk_summary_virus_count.cwl/mk_summary_virus_count/input_STARLog",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                },
                {
                    "id": "#mk_summary_virus_count.cwl/mk_summary_virus_count/input_virus_count",
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    }
                },
                {
                    "id": "#mk_summary_virus_count.cwl/mk_summary_virus_count/input_layout",
                    "type": "string",
                    "inputBinding": {
                        "position": 4
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#mk_summary_virus_count.cwl/mk_summary_virus_count/output",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "*"
                    }
                }
            ],
            "label": "mk_summary_virus_count",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "yyasumizu/mk_summary_virus_count:1.1"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#mk_virus_count.cwl",
            "baseCommand": [
                "samtools",
                "view"
            ],
            "inputs": [
                {
                    "id": "#mk_virus_count.cwl/mk_virus_count/virus_bam",
                    "type": "File",
                    "inputBinding": {
                        "position": -2,
                        "shellQuote": false
                    }
                },
                {
                    "id": "#mk_virus_count.cwl/mk_virus_count/hit_cutoff",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "shellQuote": false
                    },
                    "https://www.sevenbridges.com/toolDefaultValue": "400"
                }
            ],
            "outputs": [
                {
                    "id": "#mk_virus_count.cwl/mk_virus_count/virus_count",
                    "type": "File",
                    "outputBinding": {
                        "glob": "virus_counts.txt"
                    }
                }
            ],
            "label": "mk_virus_count",
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "| cut -f3 | sort | uniq -c | awk '{if ($1>="
                },
                {
                    "position": 2,
                    "shellQuote": false,
                    "valueFrom": ") print $0}'"
                }
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/samtools:1.2-0"
                }
            ],
            "stdout": "virus_counts.txt"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "salmon",
                "quant"
            ],
            "inputs": [
                {
                    "id": "#salmon-quant.cwl/index",
                    "type": "Directory",
                    "inputBinding": {
                        "position": -2,
                        "prefix": "-i",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#salmon-quant.cwl/inf1",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-1",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#salmon-quant.cwl/inf2",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-2",
                        "shellQuote": false
                    }
                },
                {
                    "default": "A",
                    "id": "#salmon-quant.cwl/libType",
                    "type": "string",
                    "inputBinding": {
                        "position": -2,
                        "prefix": "-l",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#salmon-quant.cwl/quantdir",
                    "type": "string",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-o",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#salmon-quant.cwl/runThreadN",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-p",
                        "shellQuote": false
                    },
                    "doc": "1\nint: number of threads to run Salmon\n"
                },
                {
                    "id": "#salmon-quant.cwl/gcBias",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 6,
                        "prefix": "--gcBias"
                    }
                },
                {
                    "id": "#salmon-quant.cwl/validateMappings",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 6,
                        "prefix": "--validateMappings"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#salmon-quant.cwl/output_quantdir",
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.quantdir)"
                    }
                }
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "combinelab/salmon:1.1.0"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "id": "#salmon-quant.cwl"
        },
        {
            "class": "CommandLineTool",
            "id": "#bam_filter_polyx.cwl",
            "baseCommand": [
                "bam_filter_polyx.sh"
            ],
            "inputs": [
                {
                    "id": "#bam_filter_polyx.cwl/bam_filter_polyx/input",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "shellQuote": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#bam_filter_polyx.cwl/bam_filter_polyx/output",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "virusAligned.filtered.sortedByCoord.out.bam"
                    }
                }
            ],
            "label": "bam_filter_polyX",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "yyasumizu/bam_filter_polyx:1.2"
                }
            ],
            "stdout": "virusAligned.filtered.sortedByCoord.out.bam"
        },
        {
            "class": "CommandLineTool",
            "id": "#samtools-view.cwl",
            "baseCommand": [
                "samtools_view_removemulti.sh"
            ],
            "inputs": [
                {
                    "id": "#samtools-view.cwl/samtools_view/threads",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 4,
                    "inputBinding": {
                        "position": 0,
                        "prefix": "",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#samtools-view.cwl/samtools_view/f",
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 4,
                    "inputBinding": {
                        "position": 3,
                        "prefix": "",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#samtools-view.cwl/samtools_view/prefix",
                    "default": "human",
                    "type": [
                        "null",
                        "string"
                    ],
                    "label": "prefix"
                },
                {
                    "id": "#samtools-view.cwl/samtools_view/bam",
                    "type": "File",
                    "inputBinding": {
                        "position": 5,
                        "shellQuote": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#samtools-view.cwl/samtools_view/output",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.prefix).unmapped.bam"
                    }
                }
            ],
            "label": "samtools-view",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "yyasumizu/bam_filter_polyx:1.1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "stdout": "$(inputs.prefix).unmapped.bam"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "STAR",
                "--runMode",
                "alignReads"
            ],
            "inputs": [
                {
                    "id": "#star_mapping-pe.cwl/fq1",
                    "type": "File",
                    "inputBinding": {
                        "position": 50,
                        "prefix": "--readFilesIn"
                    },
                    "label": "path to file that contain input read1",
                    "doc": "path to file that contain input read1"
                },
                {
                    "id": "#star_mapping-pe.cwl/fq2",
                    "type": "File",
                    "inputBinding": {
                        "position": 51
                    },
                    "label": "path to file that contain input read2",
                    "doc": "path to file that contain input read2"
                },
                {
                    "id": "#star_mapping-pe.cwl/genomeDir",
                    "type": "Directory",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--genomeDir",
                        "shellQuote": false
                    },
                    "label": "path to the directory where genome files are stored",
                    "doc": "path to the directory where genome files are stored"
                },
                {
                    "id": "#star_mapping-pe.cwl/nthreads",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--runThreadN",
                        "shellQuote": false
                    },
                    "label": "Number of threads",
                    "doc": "defines the number of threads to be used for genome generation, it has to be set to the number of available cores on the server node."
                },
                {
                    "default": "Within",
                    "id": "#star_mapping-pe.cwl/outSAMunmapped",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--outSAMunmapped",
                        "shellQuote": false
                    },
                    "label": "output of unmapped reads in the SAM format",
                    "doc": "1st word: None: no output, Within: output unmapped reads within the main SAM file (i.e. Aligned.out.sam). 2nd word: KeepPairs: record unmapped mate for each alignment, and, in case of unsorted output, keep it adjacent to its mapped mate. Only a\u21b5ects multi-mapping reads."
                },
                {
                    "default": "STAR",
                    "id": "#star_mapping-pe.cwl/output_dir_name",
                    "type": [
                        "null",
                        "string"
                    ],
                    "label": "Name of the directory to write output files in",
                    "doc": "Name of the directory to write output files in"
                },
                {
                    "id": "#star_mapping-pe.cwl/outFileNamePrefix",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--outFileNamePrefix",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#star_mapping-pe.cwl/readFilesCommand",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--readFilesCommand",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#star_mapping-pe.cwl/outSAMtype",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--outSAMtype",
                        "shellQuote": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#star_mapping-pe.cwl/aligned",
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  if (inputs.outSAMtype == \"BAM Unsorted\")\n    return p+\"Aligned.out.bam\";\n  var p=inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n  return p+\"Aligned.sortedByCoord.out.bam\";\n}\n"
                    },
                    "secondaryFiles": [
                        "${\n   var p=inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n   return [\n     {\"path\": p+\"Log.final.out\", \"class\":\"File\"},\n     {\"path\": p+\"SJ.out.tab\", \"class\":\"File\"},\n     {\"path\": p+\"Log.out\", \"class\":\"File\"}\n   ];\n}\n"
                    ]
                },
                {
                    "id": "#star_mapping-pe.cwl/bamRemDups",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  if (inputs.bamRemoveDuplicatesType != \"UniqueIdentical\")\n    return null;\n  var p=inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n  return p+\"Processed.out.bam\";\n}\n"
                    }
                },
                {
                    "id": "#star_mapping-pe.cwl/mappingstats",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "loadContents": true,
                        "glob": "${\n  var p = inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n  return p+\"Log.final.out\";\n}\n"
                    }
                },
                {
                    "id": "#star_mapping-pe.cwl/readspergene",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  var p=inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n  return p+\"ReadsPerGene.out.tab\";\n}\n"
                    }
                },
                {
                    "id": "#star_mapping-pe.cwl/transcriptomesam",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  var p=inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n  return p+\"Aligned.toTranscriptome.out.bam\";\n}\n"
                    }
                },
                {
                    "id": "#star_mapping-pe.cwl/Log.out",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${   var p=inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";   return p+\"Log.out\"; }"
                    }
                },
                {
                    "id": "#star_mapping-pe.cwl/Log.progress.out",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  var p=inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n  return p+\"Log.progress.out\";\n}\n"
                    }
                },
                {
                    "id": "#star_mapping-pe.cwl/SJ.out.tab",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  var p=inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n  return p+\"SJ.out.tab\";\n}\n"
                    }
                },
                {
                    "id": "#star_mapping-pe.cwl/unmapped",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.outSAMunmapped)"
                    }
                }
            ],
            "doc": "STAR: Spliced Transcripts Alignment to a Reference. https://github.com/alexdobin/STAR/blob/master/doc/STARmanual.pdf",
            "label": "STAR mapping: running mapping jobs.",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.genomeDir)",
                            "writable": true
                        }
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/star:2.7.1a--0"
                }
            ],
            "id": "#star_mapping-pe.cwl",
            "https://schema.org/author": [
                {
                    "class": "https://schema.org/Person",
                    "https://schema.org/email": "mailto:inutano@gmail.com",
                    "https://schema.org/identifier": "https://orcid.org/0000-0003-3777-5945",
                    "https://schema.org/name": "Tazro Ohta"
                }
            ],
            "https://schema.org/codeRepository": "https://github.com/pitagora-network/pitagora-cwl",
            "https://schema.org/license": "https://spdx.org/licenses/Apache-2.0"
        },
        {
            "class": "Workflow",
            "id": "#main",
            "doc": "VIRTUS v1.2.1",
            "label": "VIRTUS.PE",
            "inputs": [
                {
                    "id": "#main/fastq2",
                    "type": "File",
                    "https://www.sevenbridges.com/x": -446.9178771972656,
                    "https://www.sevenbridges.com/y": -426.26885986328125
                },
                {
                    "id": "#main/fastq1",
                    "type": "File",
                    "https://www.sevenbridges.com/x": -445.51458740234375,
                    "https://www.sevenbridges.com/y": -274.6721496582031
                },
                {
                    "id": "#main/genomeDir_human",
                    "type": "Directory",
                    "https://www.sevenbridges.com/x": -305,
                    "https://www.sevenbridges.com/y": -602
                },
                {
                    "id": "#main/outFileNamePrefix_human",
                    "type": [
                        "null",
                        "string"
                    ],
                    "https://www.sevenbridges.com/x": -304,
                    "https://www.sevenbridges.com/y": -750
                },
                {
                    "id": "#main/nthreads",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://www.sevenbridges.com/x": -386.4197082519531,
                    "https://www.sevenbridges.com/y": 242.87530517578125
                },
                {
                    "id": "#main/genomeDir_virus",
                    "type": "Directory",
                    "https://www.sevenbridges.com/x": 417.4296875,
                    "https://www.sevenbridges.com/y": 452.7935791015625
                },
                {
                    "id": "#main/salmon_index_human",
                    "type": "Directory",
                    "https://www.sevenbridges.com/x": -313.94915771484375,
                    "https://www.sevenbridges.com/y": -922.5796508789062
                },
                {
                    "id": "#main/salmon_quantdir_human",
                    "type": "string",
                    "https://www.sevenbridges.com/x": -314.884765625,
                    "https://www.sevenbridges.com/y": -1090
                },
                {
                    "id": "#main/hit_cutoff",
                    "type": [
                        "null",
                        "int"
                    ],
                    "https://www.sevenbridges.com/x": 805.1641845703125,
                    "https://www.sevenbridges.com/y": 666.56591796875
                },
                {
                    "id": "#main/kz_threshold",
                    "type": [
                        "null",
                        "float"
                    ],
                    "doc": "default : 0.1.",
                    "https://www.sevenbridges.com/x": -296.2785949707031,
                    "https://www.sevenbridges.com/y": 411.1441650390625
                }
            ],
            "outputs": [
                {
                    "id": "#main/Log.out_human",
                    "outputSource": [
                        "#main/star_mapping_pe_human/Log.out"
                    ],
                    "type": [
                        "null",
                        "File"
                    ],
                    "https://www.sevenbridges.com/x": 201,
                    "https://www.sevenbridges.com/y": -114
                },
                {
                    "id": "#main/Log.progress.out_human",
                    "outputSource": [
                        "#main/star_mapping_pe_human/Log.progress.out"
                    ],
                    "type": [
                        "null",
                        "File"
                    ],
                    "https://www.sevenbridges.com/x": 203,
                    "https://www.sevenbridges.com/y": -268
                },
                {
                    "id": "#main/SJ.out.tab_human",
                    "outputSource": [
                        "#main/star_mapping_pe_human/SJ.out.tab"
                    ],
                    "type": [
                        "null",
                        "File"
                    ],
                    "https://www.sevenbridges.com/x": 206,
                    "https://www.sevenbridges.com/y": -521.0446166992188
                },
                {
                    "id": "#main/aligned_bam_human",
                    "outputSource": [
                        "#main/star_mapping_pe_human/aligned"
                    ],
                    "type": "File",
                    "https://www.sevenbridges.com/x": 190.84915161132812,
                    "https://www.sevenbridges.com/y": 381.26885986328125
                },
                {
                    "id": "#main/output_unmapped",
                    "outputSource": [
                        "#main/samtools_view/output"
                    ],
                    "type": "File",
                    "https://www.sevenbridges.com/x": 340.177001953125,
                    "https://www.sevenbridges.com/y": 225.9409942626953
                },
                {
                    "id": "#main/output_fq2",
                    "outputSource": [
                        "#main/bedtools_bamtofastq_pe/output_fq2"
                    ],
                    "type": [
                        "null",
                        "File"
                    ],
                    "https://www.sevenbridges.com/x": 558.2530517578125,
                    "https://www.sevenbridges.com/y": -337.0843505859375
                },
                {
                    "id": "#main/output_fq1",
                    "outputSource": [
                        "#main/bedtools_bamtofastq_pe/output_fq1"
                    ],
                    "type": "File",
                    "https://www.sevenbridges.com/x": 562.6327514648438,
                    "https://www.sevenbridges.com/y": -168
                },
                {
                    "id": "#main/SJ.out.tab_virus",
                    "outputSource": [
                        "#main/star_mapping_pe_virus/SJ.out.tab"
                    ],
                    "type": [
                        "null",
                        "File"
                    ],
                    "https://www.sevenbridges.com/x": 954.8983154296875,
                    "https://www.sevenbridges.com/y": -110.67289733886719
                },
                {
                    "id": "#main/Log.progress.out_virus",
                    "outputSource": [
                        "#main/star_mapping_pe_virus/Log.progress.out"
                    ],
                    "type": [
                        "null",
                        "File"
                    ],
                    "https://www.sevenbridges.com/x": 959.8370361328125,
                    "https://www.sevenbridges.com/y": 193.0820770263672
                },
                {
                    "id": "#main/Log.out_virus",
                    "outputSource": [
                        "#main/star_mapping_pe_virus/Log.out"
                    ],
                    "type": [
                        "null",
                        "File"
                    ],
                    "https://www.sevenbridges.com/x": 960.4492797851562,
                    "https://www.sevenbridges.com/y": 331.1433410644531
                },
                {
                    "id": "#main/aligned_virus",
                    "outputSource": [
                        "#main/star_mapping_pe_virus/aligned"
                    ],
                    "type": "File",
                    "https://www.sevenbridges.com/x": 862.1668090820312,
                    "https://www.sevenbridges.com/y": 348.64471435546875
                },
                {
                    "id": "#main/mappingstats_virus",
                    "outputSource": [
                        "#main/star_mapping_pe_virus/mappingstats"
                    ],
                    "type": [
                        "null",
                        "File"
                    ],
                    "https://www.sevenbridges.com/x": 956.122802734375,
                    "https://www.sevenbridges.com/y": 39.143333435058594
                },
                {
                    "id": "#main/mappingstats_human",
                    "outputSource": [
                        "#main/star_mapping_pe_human/mappingstats"
                    ],
                    "type": [
                        "null",
                        "File"
                    ],
                    "https://www.sevenbridges.com/x": 206.1626434326172,
                    "https://www.sevenbridges.com/y": -394.3936767578125
                },
                {
                    "id": "#main/output_quantdir_human",
                    "outputSource": [
                        "#main/salmon_quant_human/output_quantdir"
                    ],
                    "type": "Directory",
                    "https://www.sevenbridges.com/x": 300.56866455078125,
                    "https://www.sevenbridges.com/y": -715.6619262695312
                },
                {
                    "id": "#main/output",
                    "outputSource": [
                        "#main/mk_summary_virus_count/output"
                    ],
                    "type": [
                        "null",
                        "File"
                    ],
                    "https://www.sevenbridges.com/x": 1280.2369384765625,
                    "https://www.sevenbridges.com/y": -573.7061767578125
                },
                {
                    "id": "#main/output_1",
                    "outputSource": [
                        "#main/bam_filter_polyx/output"
                    ],
                    "type": [
                        "null",
                        "File"
                    ],
                    "https://www.sevenbridges.com/x": 967.21630859375,
                    "https://www.sevenbridges.com/y": 668.790283203125
                }
            ],
            "steps": [
                {
                    "id": "#main/fastp_pe",
                    "in": [
                        {
                            "id": "#main/fastp_pe/fastq1",
                            "source": "#main/fastq1"
                        },
                        {
                            "id": "#main/fastp_pe/fastq2",
                            "source": "#main/fastq2"
                        },
                        {
                            "id": "#main/fastp_pe/threads",
                            "source": "#main/nthreads"
                        },
                        {
                            "id": "#main/fastp_pe/length",
                            "default": 40
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastp_pe/out_fastq1"
                        },
                        {
                            "id": "#main/fastp_pe/out_fastq2"
                        }
                    ],
                    "run": "#fastp-pe.cwl",
                    "https://www.sevenbridges.com/x": -271.3704528808594,
                    "https://www.sevenbridges.com/y": -358.8819885253906
                },
                {
                    "id": "#main/star_mapping_pe_human",
                    "in": [
                        {
                            "id": "#main/star_mapping_pe_human/fq1",
                            "source": "#main/fastp_pe/out_fastq1"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/fq2",
                            "source": "#main/fastp_pe/out_fastq2"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/genomeDir",
                            "source": "#main/genomeDir_human"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/nthreads",
                            "source": "#main/nthreads"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/outSAMunmapped",
                            "default": "Within"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/outFileNamePrefix",
                            "source": "#main/outFileNamePrefix_human"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/outSAMtype",
                            "default": "BAM SortedByCoordinate"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/star_mapping_pe_human/aligned"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/bamRemDups"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/mappingstats"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/readspergene"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/transcriptomesam"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/Log.out"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/Log.progress.out"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/SJ.out.tab"
                        },
                        {
                            "id": "#main/star_mapping_pe_human/unmapped"
                        }
                    ],
                    "run": "#star_mapping-pe.cwl",
                    "label": "STAR mapping: running mapping jobs.",
                    "https://www.sevenbridges.com/x": -29,
                    "https://www.sevenbridges.com/y": -369
                },
                {
                    "id": "#main/samtools_view",
                    "in": [
                        {
                            "id": "#main/samtools_view/threads",
                            "source": "#main/nthreads"
                        },
                        {
                            "id": "#main/samtools_view/f",
                            "default": 4
                        },
                        {
                            "id": "#main/samtools_view/prefix",
                            "default": "human"
                        },
                        {
                            "id": "#main/samtools_view/bam",
                            "source": "#main/star_mapping_pe_human/aligned"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/samtools_view/output"
                        }
                    ],
                    "run": "#samtools-view.cwl",
                    "label": "samtools-view",
                    "https://www.sevenbridges.com/x": 179.7147216796875,
                    "https://www.sevenbridges.com/y": 53.134429931640625
                },
                {
                    "id": "#main/bedtools_bamtofastq_pe",
                    "in": [
                        {
                            "id": "#main/bedtools_bamtofastq_pe/input",
                            "source": "#main/samtools_view/output"
                        },
                        {
                            "id": "#main/bedtools_bamtofastq_pe/fq",
                            "default": "unmapped_1.fq"
                        },
                        {
                            "id": "#main/bedtools_bamtofastq_pe/fq2",
                            "default": "unmapped_2.fq"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/bedtools_bamtofastq_pe/output_fq1"
                        },
                        {
                            "id": "#main/bedtools_bamtofastq_pe/output_fq2"
                        }
                    ],
                    "run": "#bedtools-bamtofastq-pe.cwl",
                    "label": "bedtools-bamtofastq-pe",
                    "https://www.sevenbridges.com/x": 315.8917236328125,
                    "https://www.sevenbridges.com/y": -33.99026870727539
                },
                {
                    "id": "#main/star_mapping_pe_virus",
                    "in": [
                        {
                            "id": "#main/star_mapping_pe_virus/fq1",
                            "source": "#main/fastq_pair/fq1_paired"
                        },
                        {
                            "id": "#main/star_mapping_pe_virus/fq2",
                            "source": "#main/fastq_pair/fq2_paired"
                        },
                        {
                            "id": "#main/star_mapping_pe_virus/genomeDir",
                            "source": "#main/genomeDir_virus"
                        },
                        {
                            "id": "#main/star_mapping_pe_virus/nthreads",
                            "source": "#main/nthreads"
                        },
                        {
                            "id": "#main/star_mapping_pe_virus/outFileNamePrefix",
                            "default": "virus"
                        },
                        {
                            "id": "#main/star_mapping_pe_virus/outSAMtype",
                            "default": "BAM SortedByCoordinate"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/star_mapping_pe_virus/aligned"
                        },
                        {
                            "id": "#main/star_mapping_pe_virus/bamRemDups"
                        },
                        {
                            "id": "#main/star_mapping_pe_virus/mappingstats"
                        },
                        {
                            "id": "#main/star_mapping_pe_virus/readspergene"
                        },
                        {
                            "id": "#main/star_mapping_pe_virus/transcriptomesam"
                        },
                        {
                            "id": "#main/star_mapping_pe_virus/Log.out"
                        },
                        {
                            "id": "#main/star_mapping_pe_virus/Log.progress.out"
                        },
                        {
                            "id": "#main/star_mapping_pe_virus/SJ.out.tab"
                        },
                        {
                            "id": "#main/star_mapping_pe_virus/unmapped"
                        }
                    ],
                    "run": "#star_mapping-pe.cwl",
                    "label": "STAR mapping: running mapping jobs.",
                    "https://www.sevenbridges.com/x": 753.9961547851562,
                    "https://www.sevenbridges.com/y": 133.0281219482422
                },
                {
                    "id": "#main/mk_virus_count",
                    "in": [
                        {
                            "id": "#main/mk_virus_count/virus_bam",
                            "source": "#main/bam_filter_polyx/output"
                        },
                        {
                            "id": "#main/mk_virus_count/hit_cutoff",
                            "default": 400,
                            "source": "#main/hit_cutoff"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/mk_virus_count/virus_count"
                        }
                    ],
                    "run": "#mk_virus_count.cwl",
                    "label": "mk_virus_count",
                    "https://www.sevenbridges.com/x": 963.22509765625,
                    "https://www.sevenbridges.com/y": 479.8780822753906
                },
                {
                    "id": "#main/salmon_quant_human",
                    "in": [
                        {
                            "id": "#main/salmon_quant_human/index",
                            "source": "#main/salmon_index_human"
                        },
                        {
                            "id": "#main/salmon_quant_human/inf1",
                            "source": "#main/fastp_pe/out_fastq1"
                        },
                        {
                            "id": "#main/salmon_quant_human/inf2",
                            "source": "#main/fastp_pe/out_fastq2"
                        },
                        {
                            "id": "#main/salmon_quant_human/libType",
                            "default": "A"
                        },
                        {
                            "id": "#main/salmon_quant_human/quantdir",
                            "default": "salmon_quantdir_human",
                            "source": "#main/salmon_quantdir_human"
                        },
                        {
                            "id": "#main/salmon_quant_human/runThreadN",
                            "source": "#main/nthreads"
                        },
                        {
                            "id": "#main/salmon_quant_human/gcBias",
                            "default": true
                        },
                        {
                            "id": "#main/salmon_quant_human/validateMappings",
                            "default": true
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/salmon_quant_human/output_quantdir"
                        }
                    ],
                    "run": "#salmon-quant.cwl",
                    "https://www.sevenbridges.com/x": 85.66854095458984,
                    "https://www.sevenbridges.com/y": -717.1351318359375
                },
                {
                    "id": "#main/mk_summary_virus_count",
                    "in": [
                        {
                            "id": "#main/mk_summary_virus_count/input_STARLog",
                            "source": "#main/star_mapping_pe_human/mappingstats"
                        },
                        {
                            "id": "#main/mk_summary_virus_count/input_virus_count",
                            "source": "#main/mk_virus_count/virus_count"
                        },
                        {
                            "id": "#main/mk_summary_virus_count/input_layout",
                            "default": "PE"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/mk_summary_virus_count/output"
                        }
                    ],
                    "run": "#mk_summary_virus_count.cwl",
                    "label": "mk_summary_virus_count",
                    "https://www.sevenbridges.com/x": 1132.9288330078125,
                    "https://www.sevenbridges.com/y": -576.298583984375
                },
                {
                    "id": "#main/bam_filter_polyx",
                    "in": [
                        {
                            "id": "#main/bam_filter_polyx/input",
                            "source": "#main/star_mapping_pe_virus/aligned"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/bam_filter_polyx/output"
                        }
                    ],
                    "run": "#bam_filter_polyx.cwl",
                    "label": "bam_filter_polyX",
                    "https://www.sevenbridges.com/x": 825.17626953125,
                    "https://www.sevenbridges.com/y": 513.4646606445312
                },
                {
                    "id": "#main/kz_filter_fq2",
                    "in": [
                        {
                            "id": "#main/kz_filter_fq2/threshold",
                            "default": 0.1,
                            "source": "#main/kz_threshold"
                        },
                        {
                            "id": "#main/kz_filter_fq2/input_fq",
                            "source": "#main/bedtools_bamtofastq_pe/output_fq2"
                        },
                        {
                            "id": "#main/kz_filter_fq2/output_fq",
                            "default": "kz_2.fq"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/kz_filter_fq2/output"
                        }
                    ],
                    "run": "#kz_filter.cwl",
                    "label": "kz-filter_fq2",
                    "https://www.sevenbridges.com/x": 460.7408752441406,
                    "https://www.sevenbridges.com/y": 27.032846450805664
                },
                {
                    "id": "#main/kz_filter_fq1",
                    "in": [
                        {
                            "id": "#main/kz_filter_fq1/threshold",
                            "default": 0.1,
                            "source": "#main/kz_threshold"
                        },
                        {
                            "id": "#main/kz_filter_fq1/input_fq",
                            "source": "#main/bedtools_bamtofastq_pe/output_fq1"
                        },
                        {
                            "id": "#main/kz_filter_fq1/output_fq",
                            "default": "kz_1.fq"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/kz_filter_fq1/output"
                        }
                    ],
                    "run": "#kz_filter.cwl",
                    "label": "kz-filter_fq1",
                    "https://www.sevenbridges.com/x": 462.7408752441406,
                    "https://www.sevenbridges.com/y": 147
                },
                {
                    "id": "#main/fastq_pair",
                    "in": [
                        {
                            "id": "#main/fastq_pair/fq1",
                            "source": "#main/kz_filter_fq1/output"
                        },
                        {
                            "id": "#main/fastq_pair/fq2",
                            "source": "#main/kz_filter_fq2/output"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastq_pair/fq1_paired"
                        },
                        {
                            "id": "#main/fastq_pair/fq2_paired"
                        }
                    ],
                    "run": "#fastq_pair.cwl",
                    "label": "fastq_pair",
                    "https://www.sevenbridges.com/x": 577.2360229492188,
                    "https://www.sevenbridges.com/y": 93.92456817626953
                }
            ],
            "requirements": [],
            "https://www.sevenbridges.com/license": "CC BY-NC 4.0",
            "https://www.sevenbridges.com/toolAuthor": "Yoshiaki Yasumizu"
        }
    ],
    "cwlVersion": "v1.0",
    "$namespaces": {
        "sbg": "https://www.sevenbridges.com/"
    }
}
